
/*  -*- MaTX -*-
 *
 *  ̾
 *      cond() - (2-Υ)
 *
 *  ڷ
 *      c = cond(A)
 *         Real c;
 *         Matrix A;
 *
 *  ڵǽ
 *      cond()ϡ2-Υ˴ؤ롣ϡ
 *      ðͤȺǾðͤͿ졤1 ʾǤ롣
 *
 *  ڥ르ꥺ
 *      ðʬѤ롣
 *
 *  ա
 *      ֤׻ðͤޤʤϡΥåɽ롣
 *
 *          Solution will not converge
 *
 *  
 *      >> A = [[1 2 3][4 5 6]];
 *      >> k = cond(A)
 *      k = 12.3022
 *
 *  ڴϢܡ
 *      svd, rank, singval
 */

Func Real cond(A)
	Matrix A;
{
	Real c;
	Matrix sg;

	// 
	if (length(A) == 0) {
		warning("cond(): \n");
		c = NaN;
	} else {
		sg = singval(A);
		// ð۹
		if (any(sg .== 0)) {
			warning("cond(): ̵硣\n");
			c = Inf;
		} else {
			c = max(sg)/min(sg);
		}
	}
	
	return c;
}
