
/*  -*- MaTX -*-
 *
 *  ̾
 *      Ode45() - RKF45ˡǾʬ
 *
 *  ڷ
 *      {T,X} = Ode45(t0,t1,x0,diff_eqs)
 *         Array T,X,U;
 *         Real t0,t1;
 *         Matrix x0;
 *         Matrix diff_eqs(t,x,u); (Real t; Matrix x,u;)
 *
 *      {T,X,U} = Ode45(t0,t1,x0,diff_eqs,link_eqs)
 *         Array T,X,U;
 *         Real t0,t1;
 *         Matrix x0;
 *         Matrix diff_eqs(t,x,u); (Real t; Matrix x,u;)
 *         Matrix link_eqs(t,x);   (Real t; Matrix x;)
 *
 *      {T,X,U} = Ode45(t0,t1,x0,diff_eqs,link_eqs,h)
 *         Array T,X,U;
 *         Real t0,t1;
 *         Matrix x0;
 *         Matrix diff_eqs(t,x,u); (Real t; Matrix x,u;)
 *         Matrix link_eqs(t,x);   (Real t; Matrix x;)
 *         Real h;
 *
 *      {T,X,U} = Ode45(t0,t1,x0,diff_eqs,link_eqs,h,dtsav)
 *         Array T,X,U;
 *         Real t0,t1;
 *         Matrix x0;
 *         Matrix diff_eqs(t,x,u); (Real t; Matrix x,u;)
 *         Matrix link_eqs(t,x);   (Real t; Matrix x;)
 *         Real h,dtsav;
 *
 *  ڵǽ
 *      {T,X} = Ode45(t0,t1,x0,diff_eqs)ϡؿdiff_eqs()
 *      ʬ RKF45 ˡȤ h = 4.0E-2 ǲ򤭡֤
 *       X Ȼ֤η T ֤ƻˤǤڤ
 *       h^6 Ǥ롣
 *
 *      {T,X,U} = Ode45(t0,t1,x0,diff_eqs,link_eqs)ϡؿ link_eqs() 
 *      ׻̤ u Ȥơؿ diff_eqs() Ϥʤ顤ʬ
 *      򤭡֤λ Xλ U֤η T 
 *      ֤
 *
 *      Ode45(t0,t1,x0,diff_eqs,link_eqs,h)ϡ h Ǿʬ
 *      򤯡
 *
 *      Ode45(t0,t1,x0,diff_eqs,link_eqs,h,dtsav)ϡ¸ǡδֳ֤
 *      dtsav ʾˤǡְ
 *
 *      ΰ̣򼡤˼
 *
 *          t0              : 
 *          t1              : ü
 *          x0              : 
 *          diff_eqs(t,x,u) :  t x u 
 *                          : ֤ʬ׻
 *          link_eqs(t,x)   :  t x 鳰׻
 *          h               : 
 *          dtsave          : ǡ¸κǾֳ
 *
 *  
 *      桼ޥ˥奢뻲ȡ
 *
 *  ڴϢܡ
 *      rkf45(), Ode45Auto(), Ode45Hybrid(), Ode45HybridAuto()
 */
