
/*  -*- MaTX -*-
 *
 *  ̾
 *      Ode45Auto() - RKF45ˡ(ưĴ)Ǿʬ
 *
 *  ڷ
 *      {T,X} = Ode45Auto(t0,t1,x0,diff_eqs)
 *         Array T,X,U;
 *         Real t0,t1;
 *         Matrix x0;
 *         Matrix diff_eqs(t,x,u); (Real t; Matrix x,u;)
 *
 *      {T,X,U} = Ode45Auto(t0,t1,x0,diff_eqs,link_eqs)
 *         Array T,X,U;
 *         Real t0,t1;
 *         Matrix x0;
 *         Matrix diff_eqs(t,x,u); (Real t; Matrix x,u;)
 *         Matrix link_eqs(t,x);   (Real t; Matrix x;)
 *
 *      {T,X,U} = Ode45Auto(t0,t1,x0,diff_eqs,link_eqs,eps)
 *         Array T,X,U;
 *         Real t0,t1;
 *         Matrix x0;
 *         Matrix diff_eqs(t,x,u); (Real t; Matrix x,u;)
 *         Matrix link_eqs(t,x);   (Real t; Matrix x;)
 *         Real eps;
 *
 *      {T,X,U} = Ode45Auto(t0,t1,x0,diff_eqs,link_eqs,eps,dtsav)
 *         Array T,X,U;
 *         Real t0,t1;
 *         Matrix x0;
 *         Matrix diff_eqs(t,x,u); (Real t; Matrix x,u;)
 *         Matrix link_eqs(t,x);   (Real t; Matrix x;)
 *         Real eps,dtsav;
 *
 *      {T,X,U} = Ode45Auto(t0,t1,x0,diff_eqs,link_eqs,eps,dtsav,dtmin)
 *         Array T,X,U;
 *         Real t0,t1;
 *         Matrix x0;
 *         Matrix diff_eqs(t,x,u); (Real t; Matrix x,u;)
 *         Matrix link_eqs(t,x);   (Real t; Matrix x;)
 *         Real eps,dtsav,dtmin;
 *
 *      {T,X,U} = Ode45Auto(t0,t1,x0,diff_eqs,link_eqs,eps,dtsav,
 *                                                         dtmin,dtmax)
 *         Array T,X,U;
 *         Real t0,t1;
 *         Matrix x0;
 *         Matrix diff_eqs(t,x,u); (Real t; Matrix x,u;)
 *         Matrix link_eqs(t,x);   (Real t; Matrix x;)
 *         Real eps,dtsav,dtmin,dtmax;
 *
 *  ڵǽ
 *      {T,X} = Ode45Auto(t0,t1,x0,diff_eqs)ϡؿdiff_eqs()
 *      ʬ RKF45ˡȤƻˤ eps = 1.0E-6 
 *      ʲˤʤ褦ưĴᤷʤ򤭡֤λ X Ȼ֤
 *       T ֤ 
 *
 *      κǾͤϡdtmin = EPSͤ dtmax = abs(t1-t0)/5
 *      ǡ¸κǾֳ֤ϡdtsav = 1.0E-3 Ǥ롣 dtmin 
 *      Ƥ⡤ eps ʲˤʤʤ硤ٹåɽ
 *      λؿʤࡣ
 *
 *      {T,X,U} = Ode45Auto(t0,t1,x0,diff_eqs,link_eqs)ϡlink_eqs()
 *      η׻̤ u Ȥơؿ diff_eqs() Ϥʤ顤ʬ
 *      򤭡֤λ Xλ U֤η T 
 *      ֤
 *
 *      Ode45Auto(t0,t1,x0,diff_eqs,link_eqs,eps)ϡƻˤ
 *       eps ˤʤ褦Ĵᤷʤʬ򤯡
 *
 *      Ode45Auto(t0,t1,x0,diff_eqs,link_eqs,eps,dtsav)ϡ¸ǡ
 *      δֳ֤ dtsav ʾˤǡְ
 *
 *      Ode45Auto(t0,t1,x0,diff_eqs,link_eqs,eps,dtsav,dtmin)ϡ
 *      Ǿͤ dtmin ˤ롣
 *
 *      Ode45Auto(t0,t1,x0,diff_eqs,link_eqs,eps,dtsav,dtmin,dtmax)ϡ
 *      κͤ dtmax ˤ롣
 *
 *      ΰ̣򼡤˼
 *
 *          t0              : 
 *          t1              : ü
 *          x0              : 
 *          diff_eqs(t,x,u) :  t x u 
 *                          : ֤ʬ׻
 *          link_eqs(t,x)   :  t x 鳰׻
 *          eps             : ƻǤڤκ
 *          dtsave          : ǡ¸κǾֳ
 *          dtmin           : κǾ
 *          dtmax           : κ
 *
 *  
 *      桼ޥ˥奢뻲ȡ
 *
 *  ڴϢܡ
 *      rkf45(), Ode45(), Ode45Hybrid(), Ode45HybridAuto()
 */
