
/*  -*- MaTX -*-
 *
 *  ̾
 *      Ode45Hybrid() - RKF45ˡǾʬ
 *                      (򥵥ץ˹)
 *
 *  ڷ
 *      {T,X,U} = Ode45Hybrid(t0,t1,dt,x0,diff_eqs,link_eqs)
 *         Array T,X,U;
 *         Real t0,t1,dt;
 *         Matrix x0;
 *         Matrix diff_eqs(t,x,u); (Real t; Matrix x,u;)
 *         Matrix link_eqs(t,x);   (Real t; Matrix x;)
 *
 *      {T,X,U} = Ode45Hybrid(t0,t1,dt,x0,diff_eqs,link_eqs,h)
 *         Array T,X,U;
 *         Real t0,t1,dt;
 *         Matrix x0;
 *         Matrix diff_eqs(t,x,u); (Real t; Matrix x,u;)
 *         Matrix link_eqs(t,x);   (Real t; Matrix x;)
 *         Real h;
 *
 *      {T,X,U} = Ode45Hybrid(t0,t1,dt,x0,diff_eqs,link_eqs,h,dtsav)
 *         Array T,X,U;
 *         Real t0,t1,dt;
 *         Matrix x0;
 *         Matrix diff_eqs(t,x,u); (Real t; Matrix x,u;)
 *         Matrix link_eqs(t,x);   (Real t; Matrix x;)
 *         Real h,dtsav;
 *
 *  ڵǽ
 *      {T,X,U} = Ode45Hybrid(t0,t1,x0,diff_eqs,link_eqs)ϡdiff_eqs()
 *      ʬ RKF45 ˡȤ h = 4.0E-2 
 *      ,֤λ Xλ U֤η T ֤ƻ
 *      ˤǤڤΥ h^6 Ǥ롣
 *
 *      ץ󥰻 dt  link_eqs() ƤӽФdiff_eqs() Ϥ
 *       u 򹹿롣
 *
 *      Ode45Hybrid(t0,t1,dt,x0,diff_eqs,link_eqs,h)ϡ h Ǿʬ
 *      򤯡
 *
 *      Ode45Hybrid(t0,t1,dt,x0,diff_eqs,link_eqs,h,dtsav)ϡ¸ǡ
 *      δֳ֤ dtsav ʾˤǡְ
 *
 *      ΰ̣򼡤˼
 *
 *          t0              : 
 *          t1              : ü
 *          dt              : ץ󥰻
 *          x0              : 
 *          diff_eqs(t,x,u) :  t x u 
 *                          : ֤ʬ׻
 *          link_eqs(t,x)   :  t x 鳰׻
 *          h               : 
 *          dtsave          : ǡ¸κǾֳ
 *
 *  
 *      桼ޥ˥奢뻲ȡ
 *
 *  ڴϢܡ
 *      rkf45(), Ode45(), Ode45Auto(), Ode45HybridAuto()
 */
