
/*  -*- MaTX -*-
 *
 *  ̾
 *      sig_demo() - ġܥåΥǥ󥹥ȥ졼
 *
 *  ڷ
 *      sig_demo()
 *
 */

Func void sig_demo()
{
	Integer n;
	List demos;

	void demo_spectral_analysis();
	void demo_fourier_expansion();
	void demo_convolution();


	demos = {"<<<  ġܥå  >>>",
			 "FFT ˤ륹ڥȥ",
			 "ȤˤȤι",
			 "߹ߤ(ѡХ)",
			 "  λ"};

	n = 1;
	while (1) {
		n = menu(demos, n);
		switch (n) {
		  case 1:
			demo_spectral_analysis();
			break;
		  case 2:
			demo_fourier_expansion();
			break;
		  case 3:
			demo_convolution();
			break;
		  default:
			return;
		}
		n++;
	}
}

Func void demo_spectral_analysis()
{
	Integer win;
	Array Y, x, y, Pyy, f, t;

	win = mgplot_cur_win();

	clear;
	print "\n";
	print " fft() ѤڥȥϤˡҲ𤹤롣\n";
	print "FFT ̾Ūϡ줿μȿʬդ\n";
	print "ȤǤ롣\n\n";
	pause;

	print "ޤǡ롣1000 Hzǥץ뤵줿ǡͤ롣\n";
	print " 0  0.25 äޤ 1 ߥλּ뤳Ȥ";
	print "Ϥ褦\n\n";
	print "\tt = [0:0.001:0.25];\n\n";
	pause;
	t = [0:0.001:0.25];

	print "\n";
	print "ˡ40 Hz  130 Hz ο¤롣\n\n";
	print "\tx = sin(2*PI*40*t) + sin(2*PI*130*t);\n\n";
	pause;
	x = sin(2*PI*40*t) + sin(2*PI*130*t);

	print "\n";
	print "ơɸк 2 򿧻򿮹 x ˲ä y Ȥ롣\n\n";
	print "\ty = x + 2*randn(t);\n\n";
	pause;
	y = x + 2*randn(t);

	print "\n";
	print "Ǳ줿 y ץåȤ褦\n\n";
	print "\tmgplot_title(win,\"Noisy time domain signal\");\n";
	print "\tmgplot_xlabel(win, \"time [s]\");\n";
	print "\tmgplot(win, t(1:50), y(1:50), {\"noisy signal\"});\n\n";
	pause;

	mgplot_reset(win);
	mgplot_title(win,"Noisy time domain signal");
	mgplot_xlabel(win, "time [s]");
	mgplot(win,t(1:50),y(1:50),{"noisy signal"});

	clear;
	print "\n";
	print "餫ˡο椫鸵μȿʬƱꤹΤ񤷤\n";
	print "Τ᥹ڥȥϤͭǤ롣\n\n";

	print "Ǳ줿 y ΥաꥨѴϴñ˵ޤ롣\n";
	print "Τ褦˹®աꥨѴ(FFT)ɤ\n\n";
	print "\tY = fft(y, 256);\n\n";
	pause;
	Y = fft(y,256);

	print "\n";
	print "줾μȿˤѥڥȥ̩(ͥ륮μ)\n";
	print "ϼΤ褦˵ޤ롣\n\n";
	print "\tPyy = Re(Y .* conj(Y));\n\n";
	pause;
	Pyy = Re(Y .* conj(Y));

	print "\n";
	print "ѥڥȥ̩٤ץåȤ뤿ȿ롣\n\n";
	print "\tf = 1000*[0:127]/256;\n\n";
	pause;
	f = 1000*[0:127]/256;

	print "\n";
	print "ѥڥȥ̩٤ΤϤ 127 Ѥ롣Ĥ\n";
	print "оŪʷȤʤ롣ơѥڥȥ̩٤ץåȤ褦\n\n";
	print "\tmgplot_title(win, \"Power spectral density\");\n";
	print "\tmgplot_xlabel(win, \"Frequency (Hz)\");\n";
	print "\tmgplot(win, f, Pyy(1:128), {\"power spectral density\"});\n\n";
	pause;

	mgplot_reset(win);
	mgplot_title(win,"Power spectral density");
	mgplot_xlabel(win,"Frequency (Hz)");
	mgplot(win,f,Pyy(1:128),{"power spectral density"});

	print "\n";
	print "।󤷡200 Hz ޤǤץåȤ褦\n\n";
	print "\tmgplot_title(win,\"Power spectral density\");\n";
	print "\tmgplot_xlabel(win,\"Frequency (Hz)\");\n";
	print "\tmgplot(f(1:50),Pyy(1:50),{\"power spectral density\"});\n\n";
	pause;

	mgplot_reset(win);
	mgplot_title(win,"Power spectral density");
	mgplot_xlabel(win,"Frequency (Hz)");
	mgplot(win,f(1:50),Pyy(1:50),{"power spectral density"});
}

/*  -*- MaTX -*-
 *
 *  ̾
 *      demo_fourier_expansion() - աꥨŸΥǥ󥹥ȥ졼
 *
 *  ڷ
 *      demo_fourier_expansion()
 *
 */

Func void demo_fourier_expansion()
{
	Integer win,k;
	Array t,y,x,yy;

	win = mgplot_cur_win();

	clear;
	print "\n";
	print "ȤΥաꥨŸϴȤ¤ɽ뤳Ȥ\n";
	print "MaTX ȤäƥեĴ٤ޤ礦\n\n";

	print "ޤ0  10 ޤ 0.1 ߤǻ֥٥ȥꡤƤ\n";
	print " sin() ׻롣\n\n";
	print "\tt = [0:0.1:10];\n";
	print "\ty = sin(t);\n";
	print "\tmgplot(win,t,y,{\"sin(t)\"});\n\n";
	print "ܼȿȷץåȤޤ礦\n\n";
	pause;

	t = [0:0.1:10];
	y = sin(t);
	mgplot(win,t,y,{"sin(t)"});

	print "ˡ 3 ȿȷܼȿȷ˲äץåȤޤ";
	print "\n\n";
	print "\ty = sin(t) + sin(3*t)/3;\n";
	print "\tmgplot(win,t,y,{\"sin(t)+sin(3*t)/3\"});\n\n";
	pause;

	y = sin(t) + sin(3*t)/3;
	mgplot(win,t,y,{"sin(t)+sin(3*t)/3"});

	print "ˡ 1 3 5 7 9 ȿȷä";
	print "ץåȤޤ\n\n";

	print "\ty = sin(t) + sin(3*t)/3 + sin(5*t)/5 + sin(7*t)/7 + sin(9*t)/9;\n";
	print "\tmgplot(win,t,y,{\"\"});\n\n";
	pause;

	y = sin(t) + sin(3*t)/3 + sin(5*t)/5 + sin(7*t)/7 + sin(9*t)/9;
	mgplot(win,t,y,{""});

	print "ܼȿ 19 ȿޤȷ\n";
	print "˲äȷ¸ޤ";
	print "\n\n";

	print "\tt = [0:0.02:3.14];\n";
	print "\ty = Z(10,length(t));\n";
	print "\tx = Z(t);\n\n";

	print "\tfor (k = 1; k <= lenght(t); k = k + (2)) {\n";
	print "\t\tx = x + sin(k*t)/k;\n";
	print "\t\ty((k+1)/2,:) = x;\n";
	print "\t}\n\n";
	pause;

	t = [0:0.02:3.14];
	y = Z(10,length(t));
	x = Z(t);

	for (k = 1; k <= 19; k = k + 2) {
		x = x + sin(k*t)/k; 
		y((k+1)/2,:) = x;
	}

	print "ȷץåȤơȷǤͻҤ򸫤";
	print "礦\n";
	print "Ȥξüͤ˼«ʤȤץĸݤդޤ礦";
	print "\n\n";

	print "\tmgplot(win,t,y(1:2:9,:),{\"\"});\n";
	print "\tmgplot_title(win,\"The building of a square wave: Gibbs effect\");";
	print "\n\n";
	pause;

	yy = y(1:2:9,:);
	mgplot(win, t, yy, {"1st","5rd","9th","13th","17th"});
	mgplot_title(win, "The building of a square wave: Gibbs effect");
}


/*  -*- MaTX -*-
 *
 *  ̾
 *      demo_convolution() - ߹ߤΥǥ󥹥ȥ졼
 *
 *  ڷ
 *      demo_convolution()
 */

Func void demo_convolution()
{
	Array XY,X,Y,x,y,zfreq,ztime;
	
	clear;
	print "\n";
	print "ΰˤ߹ߤϼȿΰˤ軻\n";
	print "ǤȤ¤ƥΤƤ롣MaTX  fft()\n";
	print "conv() ؿȤäơΤȤŪĴ٤褦\n\n";

	print "ޤǤդФ줿ͤʤ2Ĥο롣\n\n";
	print "\tx = [1 2 3 4];\n";
	print "\ty = [5 4 3 2 1];\n\n";
	pause; 
	x = [1 2 3 4];
	y = [5 4 3 2 1];

	print "ΰˤ뤳ξ߹ߤ conv() Ǵñ˹Ԥ롣";
	print "\n\n";
	print "\tztime = conv(x,y);\n\n";
	ztime = conv(x,y);
	pause;

	clear;
	print "\n";
	print "ȿΰˤ軻ԤᡤȿΰѴ\n";
	print "ʤФʤʤΥաꥨѴ򤹤뤿 FFT Ȥ\n";
	print "ΰξ߹ߤǷ׻줿 z Ĺ 8 ʤΤǡx  y\n";
	print "Ĺ 8 Ȥʤ褦 0 ɲä롣ơFFT ¹Ԥ\n";
	print "軻̤FFT롣\n\n";
	
	print "\tx = [x, Z(1,4)];\n";
	print "\ty = [y, Z(1,3)];\n";
	print "\tX = fft(x);\n";
	print "\tY = fft(y);\n";
	print "\tXY = X * Y;\n";
	print "\tzfreq = Re(ifft(XY));\n\n";
	pause;
	
	x = [x, Z(1,4)];
	y = [y, Z(1,3)];
	X = fft(x);
	Y = fft(y);
	XY = X * Y;
	zfreq = Re(ifft(XY));

	clear;
	print "\n";
	print "FFT η̤Ⱦ߹ߤη̤Ӥ롣\n\n";
	print "\tprint ztime;\n";
	print "\tprint round(zfreq);\n\n";
	pause;
	print ztime, "\n", round(zfreq);

	print "\n";
	print "ϰϤ 2 Ĥη̤פʬ롣\n";
	print "Τ뤿ȿΰǤη̤ݤˤ";
	print "\n\n";
	pause;

	clear;
	print "\n";
	print "߹ߤη̤ FFT η̤κĴ٤褦\n\n";
	print "\tprint ztime - zfreq;\n\n";
	print ztime - zfreq;
	
	printf("\n\nĺ%16.8E Ǥ롣\n\n", max(abs(ztime - zfreq)));
}
