
/*  -*- MaTX -*-
 *
 *  ̾
 *      linspace() - ֳ֥٥ȥ
 *
 *  ڷ
 *      y = linspace(x1, x2, n, ...)
 *         Array y;
 *         Real x1, x2;
 *         ...
 *         Integer n = 100;
 *
 *  ڵǽ
 *      linspace(x1,x2) ϡx1  x2 ֳ֤ 100 ʬ䤷 100 Ĥ
 *      ͤʤԥ٥ȥ֤
 *      linspace(x1,x2,N) ϡx1  x2 ֳ֤ N ʬ䤷 N Ĥ
 *      ͤʤԥ٥ȥ֤
 *
 *  ڴϢܡ
 *      logspace
 */

Func Array linspace(x1, x2, n, ...)
	Real x1, x2;
	Integer n;
{
	Array y;
	
	error(nargchk(2, 3, nargs, "linspace"));

	if (nargs == 2) {
		n = 100;
	} 

	y = [x1 .+ [0:n-2]*(x2-x1)/(n-1), x2];
	return y;
}
