
/*  -*- MaTX -*-
 *
 *  ̾
 *      OdeHybridAuto() - 4RKˡ(ưĴ)Ǿʬ
 *                        (򥵥ץ˹)
 *  ڷ
 *      {T,X,U} = OdeHybridAuto(t0,t1,dt,x0,diff_eqs,link_eqs)
 *         Array T,X,U;
 *         Real t0,t1,dt;
 *         Matrix x0;
 *         Matrix diff_eqs(t,x,u); (Real t; Matrix x,u;)
 *         Matrix link_eqs(t,x);   (Real t; Matrix x;)
 *
 *      {T,X,U} = OdeHybridAuto(t0,t1,dt,x0,diff_eqs,link_eqs,eps)
 *         Array T,X,U;
 *         Real t0,t1,dt;
 *         Matrix x0;
 *         Matrix diff_eqs(t,x,u); (Real t; Matrix x,u;)
 *         Matrix link_eqs(t,x);   (Real t; Matrix x;)
 *         Real eps;
 *
 *      {T,X,U} = OdeHybridAuto(t0,t1,dt,x0,diff_eqs,link_eqs,eps,dtsav)
 *         Array T,X,U;
 *         Real t0,t1,dt;
 *         Matrix x0;
 *         Matrix diff_eqs(t,x,u); (Real t; Matrix x,u;)
 *         Matrix link_eqs(t,x);   (Real t; Matrix x;)
 *         Real eps,dtsav;
 *
 *      {T,X,U} = OdeHybridAuto(t0,t1,dt,x0,diff_eqs,link_eqs,eps,
 *                                                          dtsav,dtmin)
 *         Array T,X,U;
 *         Real t0,t1,dt;
 *         Matrix x0;
 *         Matrix diff_eqs(t,x,u); (Real t; Matrix x,u;)
 *         Matrix link_eqs(t,x);   (Real t; Matrix x;)
 *         Real eps,dtsav,dtmin;
 *
 *      {T,X,U} = OdeHybridAuto(t0,t1,dt,x0,diff_eqs,link_eqs,eps,
 *                                                   dtsav,dtmin,dtmax)
 *         Array T,X,U;
 *         Real t0,t1,dt;
 *         Matrix x0;
 *         Matrix diff_eqs(t,x,u); (Real t; Matrix x,u;)
 *         Matrix link_eqs(t,x);   (Real t; Matrix x;)
 *         Real eps,dtsav,dtmin,dtmax;
 *
 *  ڵǽ
 *      {T,X,U} = OdeHybridAuto(t0, t1, dt, x0, diff_eqs, link_eqs)ϡ
 *      diff_eqs()ʬ 4 Υ󥲥åΥ르
 *      ꥺȤƻˤ eps = 1.0E-6 ʲˤʤ褦
 *      ưĴᤷʤ򤭡֤λ Xλ
*       U֤η T ֤
 *
 *      ץ󥰻 dt  link_eqs() ƤӽФdiff_eqs() Ϥ
 *       u 򹹿롣
 *
 *      κǾͤϡdtmin = EPSͤ dtmax = abs(t1-t0)/5
 *      ǡ¸κǾֳ֤ϡdtsav = 1.0E-3 Ǥ롣 dtmin 
 *      Ƥ⡤ eps ʲˤʤʤ硤ٹåɽ
 *      λؿʤࡣ
 *
 *      OdeHybridAuto(t0,t1,dt,x0,diff_eqs,link_eqs,eps)ϡƻˤ
 *       eps ˤʤ褦Ĵᤷʤʬ򤯡
 *
 *      OdeHybridAuto(t0,t1,dt,x0,diff_eqs,link_eqs,eps,dtsav)ϡ¸
 *      ǡδֳ֤ dtsav ʾˤǡְ
 *
 *      OdeHybridAuto(t0,t1,dt,x0,diff_eqs,link_eqs,eps,dtsav, dtmin)
 *      ϡκǾͤ dtmin ˤ롣
 *
 *      OdeHybridAuto(t0,t1,dt,x0,diff_eqs,link_eqs,eps,dtsav, dtmin,
 *      dtmax)ϡκͤ dtmax ˤ롣
 *
 *      ΰ̣򼡤˼
 *
 *          t0              : 
 *          t1              : ü
 *          x0              : 
 *          diff_eqs(t,x,u) :  t x u 
 *                          : ֤ʬ׻
 *          link_eqs(t,x)   :  t x 鳰׻
 *          eps             : ƻǤڤκ
 *          dtsave          : ǡ¸κǾֳ
 *          dtmin           : κǾ
 *          dtmax           : κ
 *
 *  
 *      桼ޥ˥奢뻲ȡ
 *
 *  ڴϢܡ
 *      rngkut4(), Ode(), OdeAuto(), OdeHybrid()
 */
