
/*  -*- MaTX -*-
 *
 *  ̾
 *      derivative() - ʬ(Ƴؿ)
 *
 *  ڷ
 *      y = derivative(x)
 *         (Integer|Real|Complex|Polynomial|Rational) y;
 *         (Integer|Real|Complex|Polynomial|Rational) x;
 *
 *      y = derivative(x,k)
 *         (Integer|Real|Complex|Polynomial|Rational) y;
 *         (Integer|Real|Complex|Polynomial|Rational) x;
 *         Integer k;
 *
 *      Y = derivative(X)
 *         (Matrix|Array) Y;
 *         (Matrix|Array) X;
 *
 *      Y = derivative(X,k)
 *         (Matrix|Array) Y;
 *         (Matrix|Array) X;
 *         Integer k;
 *
 *  ڵǽ
 *      (|¿|ʣǿ) x ˤĤơderivative(x)ϥˤʤ롣
 *      (¿༰|ͭ¿༰) x ˤĤơderivative(x) x Ƴؿ롣
 *      derivative(x,k) ϡk Ƴؿ롣
 *
 *	    X (|)ΤȤX γʬ derivative(X(i,j)) Ѥ
 *      ̤ʤ(|)롣Y 礭 X 礭Ʊˤʤ롣
 *      derivative(X,k) ϡk Ƴؿ롣
 *
 *  
 *      >> y = derivative(3.14)
 *      y = 0
 *      >> y = derivative((3.14, 2.6))
 *      y = (0.0, 0.0)
 *      >> s = Polynomial("s");
 *      >> y = derivative((1,3)*s + (2,4))
 *      y = (1,3)
 *      >> Y = derivative([s^2+3*s+4, 2*s+1])
 *      === [Y] : (  1,  2) ===
 *           [          (  1)           ]  [          (  2)           ]
 *      (  1)          2 s + 3                          2             
 *      >> Y = derivative([s^2+3*s+4, 2*s+1],2)
 *      === [Y] : (  1,  2) ===
 *           [          (  1)           ]  [          (  2)           ]
 *      (  1)             2                             0             
 *
 *  ڴϢܡ
 *      integral()
 */
