
/*  -*- MaTX -*-
 *
 *  ̾
 *      integral() - ʬ(ʬ)
 *
 *  ڷ
 *      y = integral(x)
 *         (Integer|Real|Complex|Polynomial) y;
 *         (Integer|Real|Complex|Polynomial) x;
 *
 *      y = integral(x,k)
 *         (Integer|Real|Complex|Polynomial) y;
 *         (Integer|Real|Complex|Polynomial) x;
 *         Integer k;
 *
 *      Y = integral(X)
 *         (Matrix|Array) Y;
 *         (Matrix|Array) X;
 *
 *      Y = integral(X,k)
 *         (Matrix|Array) Y;
 *         (Matrix|Array) X;
 *         Integer k;
 *
 *  ڵǽ
 *      (|¿|ʣǿ|¿༰) x ˤĤơintegral(x) x ʬ
 *      롣integral(x,k)  k ʬ롣
 *
 *	    X (|)ΤȤX γʬ integral(X(i,j)) Ѥ
 *      ̤ʤ(|)롣Y 礭 X 礭Ʊˤʤ롣
 *      integral(X,k)  k ʬ롣
 *
 *  
 *      >> y = integral(3.14)
 *      y = 3.14 s
 *      >> y = integral((3.14, 2.6))
 *      y = (3.14, 2.6) s
 *      >> s = Polynomial("s");
 *      >> y = integral((1,3)*s + (2,4))
 *      y = (0.5,1.5) s^2 + (2,4) s
 *      >> Y = integral([2*s+1, 2])
 *      === [Y] : (  1,  2) ===
 *           [          (  1)           ]  [          (  2)           ]
 *      (  1)          s^2 + s                         2 s            
 *      >> Y = integral([2*s+1, 2], 2)
 *      === [Y] : (  1,  2) ===
 *           [          (  1)           ]  [          (  2)           ]
 *      (  1)   0.333333 s^3 + 0.5 s^2                 s^2            
 *
 *  ڴϢܡ
 *      derivative()
 */
