
/*  -*- MaTX -*-
 *
 *  ̾
 *      pow() - ߾
 *
 *  ڷ
 *      y = pow(x,k)
 *         (Integer|Real|Complex|Polynomial|Rational) y;
 *         (Integer|Real|Complex|Polynomial|Rational) x;
 *         Integer k;
 *
 *      Y = pow(X,k)
 *         (Matrix|Array) Y;
 *         (Matrix|Array) X;
 *         Integer k;
 *
 *      y = pow(x,p)
 *         (Integer|Real|Complex) y;
 *         (Integer|Real|Complex) x;
 *         Real p;
 *
 *      Y = pow(X,p)
 *         Array Y;
 *         Array X;
 *         Real p;
 *
 *      y = pow(x,c)
 *         Complex y;
 *         (Integer|Real|Complex) y;
 *         Complex c;
 *
 *      Y = pow(X,c)
 *         Array Y;
 *         Array X;
 *         Complex c;;
 *
 *      Y = pow(x,X)
 *         Array Y;
 *         (Integer|Real|Complex|Polynomial|Rational) x;
 *         Array X;
 *
 *      Y = pow(X,K)
 *         Array Y;
 *         Array X;
 *         Array K;
 *
 *  ڵǽ
 *      顼(|¿|ʣǿ|¿༰|ͭ¿༰) x ˤĤơ
 *      k ΤȤpow(x,k) x  k  x^k 롣
 *
 *	    (|) X ˤĤơk ΤȤpow(X,k)ϡX^k 
 *      롣ξ硤ʬ X(i,j)^k ׻롣
 *
 *      顼(|¿|ʣǿ) x ˤĤơp ¿ΤȤ
 *      pow(x,p) x  p  x^p 롣
 *
 *	     X ˤĤơp ¿ΤȤpow(X,k)ϡʬ X(i,j)^p 
 *      ׻롣
 *
 *      顼(|¿|ʣǿ) x ˤĤơc ʣǿΤȤ
 *      pow(x,c) x  c  x^c 롣
 *
 *	     X ˤĤơc ʣǿΤȤpow(X,c)ϡʬ X(i,j)^c 
 *      ׻롣
 *
 *      顼(|¿|ʣǿ|¿༰|ͭ¿༰) x ˤĤơ
 *      X ΤȤpow(x,X)ϡX ʬ x^X(i,j) ׻
 *      X Ʊ礭롣
 *
 *	     X ˤĤơK ΤȤpow(X,K)ϡʬ 
 *      X(i,j)^K(i,j) ׻롣X  K 礭ϰפʤФʤʤ
 *
 *  
 *      >> y = pow(2,10)
 *      y = 1024
 *      >> y = pow((2,3), 3)
 *      y = (-46,9)
 *      >> s = Polynomial("s");
 *      >> y = pow(2*s + 3, 3)
 *      y = 8 s^3 + 36 s^2 + 54 s + 27
 *      >> Y = pow([[1 2][3 4]], 3)
 *      === [Y] : (  2,  2) ===
 *                 (  1)           (  2)     
 *      (  1)  3.70000000E+01  5.40000000E+01
 *      (  2)  8.10000000E+01  1.18000000E+02
 *      >> Y = pow(Array([[1 2][3 4]]), 3)
 *      === [Y] : (  2,  2) ===
 *                 (  1)           (  2)     
 *      (  1)  1.00000000E+00  8.00000000E+00
 *      (  2)  2.70000000E+01  6.40000000E+01
 *
 *  ڴϢܡ
 *      conj(), trans()
 */
