
/*  -*- MaTX -*-
 *
 *  ̾
 *      pseudoinv() - չ
 *
 *  ڷ
 *      P = pseudoinv(A)
 *         Matrix P;
 *         Matrix A;
 *
 *      P = pseudoinv(A,tol)
 *         Matrix P;
 *         Matrix A;
 *         Real tol;
 *
 *  ڵǽ
 *      pseudoinv(A)ϡ A εչ롣pseudoinv(A,tol)ϡ
 *      tol 꾮 A ðͤ򥼥Ȥߤʤ A Υ󥯤ꤷ
 *      չ롣tol άȡEPS * norm(A,"fro") Ȥ롣
 *
 *  ڥ르ꥺ
 *      ðʬѤ롣
 *
 *      {U,D,V} = svd(A);                 // A := U * D * V#
 *      Dinv  vec2diag(diag2vec(D).~);  // гʬտ׻
 *      pseudoinv(A) := V * Dinv * U#;
 *
 *  ա
 *      ֤׻ðͤޤʤϡΥåɽ롣
 *
 *          Solution will not converge
 *
 *  
 *      >> A = [[1 2 3][4 5 6]];
 *      >> P = pseudoinv(A)
 *      === [P] : (  3,  2) ===
 *                 (  1)           (  2)     
 *      (  1) -9.44444444E-01  4.44444444E-01
 *      (  2) -1.11111111E-01  1.11111111E-01
 *      (  3)  7.22222222E-01 -2.22222222E-01
 *      >> A * P * A
 *      === [ans] : (  2,  3) ===
 *                 (  1)           (  2)           (  3)     
 *      (  1)  1.00000000E+00  2.00000000E+00  3.00000000E+00
 *      (  2)  4.00000000E+00  5.00000000E+00  6.00000000E+00
 *
 *  ڴϢܡ
 *      svd()
 *
 */
